
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用 JavaScript 进行函数式编程 (一) 翻译_javascript技巧 / iVAN</title>

    <meta name="description" content="使用 JavaScript 进行函数式编程 (一) 翻译_javascript技巧 编程范式 编程范式是一个由思考问题以及实现问题愿景的工具组成的框架.很多现代语言都是聚范式(或者说多重范式): 他们支持很多不同的编程范式,比如面向对象,元程序设计,泛函,面向过程,等等. 函数式编程范式 函数式编程就像一辆氢燃料驱动的汽车--先进的未来派,但是还没有被广泛推广.与命令式编程相反,他由一系列语句组成,这些语句用于更新执行时的全局状态.函数式编程将计算转化作表达式求值.这些表达式全由纯数学函数组成,这些数学函数都是一流的(可以被当做一般值来运用和处理),并且没有副作用. 函数式编程">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用 JavaScript 进行函数式编程 (一) 翻译_javascript技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>编程范式</strong></p>
<p>编程范式是一个由思考问题以及实现问题愿景的工具组成的框架。很多现代语言都是聚范式（或者说多重范式）： 他们支持很多不同的编程范式，比如面向对象，元程序设计，泛函，面向过程，等等。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTEucG5n.jpg"></p>
<p><strong>函数式编程范式</strong></p>
<p>函数式编程就像一辆氢燃料驱动的汽车——先进的未来派，但是还没有被广泛推广。与命令式编程相反，他由一系列语句组成，这些语句用于更新执行时的全局状态。函数式编程将计算转化作表达式求值。这些表达式全由纯数学函数组成，这些数学函数都是一流的（可以被当做一般值来运用和处理），并且没有副作用。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTIucG5n.jpg"></p>
<p>函数式编程很重视以下值：</p>
<p><strong>函数是一等要务</strong></p>
<p>我们应该将函数与编程语言中的其他类对象同样对待。换句话说，您可以将函数存储在变量里，动态创建函数，以及将函数返回或者将函数传递给其他函数。下面我们来看一个例子...</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTMucG5n.jpg"></p>
<p>一个字符串可以保存为一个变量，函数也可以，例如：</p>
<pre>
var sayHello = function() { return “Hello” };</pre>
<p>一个字符串可以保存为对象字段，函数也可以，例如：</p>
<pre>
var person = {message: “Hello”, sayHello: function() { return “Hello” }};</pre>
<p>一个字符串可以再用到时才创建，函数也可以，例如：</p>
<pre>
“Hello ” + (function() { return “World” })(); //=&gt; Hello World</pre>
<p>一个字符串可以作为输入参数传给函数，则函数也可以：</p>
<pre>
    function hellloWorld(hello, world) { return hello + world() }</pre>
<p>一个字符串可以作为函数返回值，函数也可以，例如：</p>
<pre>
return “Hello”;
return function() { return “Hello”};</pre>
<h3><strong>高阶案例</strong></h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTQucG5n.jpg"></p>
<p>如果函数将其他函数函数作为输入参数或者作为返回值，则称之为高阶函数。刚才我们已经看过了一个高阶函数的例子。下面，我们来看一下更复杂的情况。</p>
<p><strong>例1</strong>：</p>
<pre>
[1, 2, 3].forEach(alert);
// alert 弹窗显示“1" 
// alert 弹窗显示 "2" 
// alert 弹窗显示 "3”</pre>
<p><strong>例2</strong><strong>：</strong></p>
<pre>
function splat(fun) {
   return function(array) {
        return fun.apply(null, array);
   };
}
var addArrayElements = splat(function(x, y) { return x + y });
addArrayElements([1, 2]);
//=&gt; 3</pre>
<p><strong>最爱</strong><strong>纯函数</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTUucG5n.jpg"></p>
<p>纯函数不会有其他的副作用，所谓的副作用指的是函数所产生的对函数外界状态的修改。比如：</p>
<ul>
<li>修改某个变量</li>
<li>修改数据结构</li>
<li>对外界某个变量设置字段</li>
<li>抛出例外或者弹出错误信息</li>
</ul>
<p>最简单的例子就是数学函数。Math.sqrt(4) 函数总是返回2。他不会用到任何其他心寒信息，如状态或者设置参数。数学函数从来不会造成任何副作用。</p>
<h3>避免修改状态 </h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTYucG5n.jpg"></p>
<p>函数式编程支持纯粹的函数，这样的函数不能改变数据，因此大多用于创建不可改变的的数据。这种方式，不用修改一个已存在的数据结构，而且能高效的新建一个.<br />
你也许想知道，如果一个纯粹的函数通过改变一些本地数据而生产一个不可改变的返回值，是否是允许的？答案是可以。<br />
在JavaScript中极少的数据类型是默认是不可改变的。String是一个不能被改变的数据类型的例子：</p>
<pre>
   var s = "HelloWorld";
    s.toUpperCase();
    //=&gt; "HELLOWORLD"
    s;
    //=&gt; "HelloWorld"</pre>
<h3>不可改变状态的好处</h3>
<p>    •    避免混乱和增加程序的准确性：在复杂系统内，大多数难以理解的Bug是由于状态通过在程序中外部客户端代码修改而导致的。 <br />
    •    确立“快速简洁”的多线程编程：如果多线程可以修改同一个共享值，你不得不同步的获取值。这对专家来说都是十分乏味并且易出错的编程挑战。 <br />
软件事务内存和Actor模型提供了直接在线程安全方式下处理修改。</p>
<h3><strong>使用递归而非循环调用</strong></h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTcucG5n.jpg"></p>
<p>递归是最有名的函数式编程技术。如果您还不知道它的话，那么可以理解为递归函数就是一个可以调用自己的函数。</p>
<p>替代反复循环的最经典方式就是使用递归，即每次完成函数体操作之后，再继续执行集合里的下一项，直到满足结束条件。递归还天生符合某些算法实现，比如遍历树形结构（每个树枝都是一颗小树）。</p>
<p>在任何语言里，递归都是一项重要的函数式编程方式。很多函数语言甚至要求的更加严格：只支持递归遍历，而不支持显式的循环遍历。这需要语言必须保证消除了尾端调用，这是 JavasSrip 不支持的。</p>
<h3>惰性求值优于激进计算</h3>
<h3><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTgucG5n.jpg"></h3>
<p>数学定义了很多无穷集合，比如自然数（所有的正整数）。他们都是符号表示。任意特定有限的子集都在需要时求值。我们将其称之为惰性求值（也叫做非严格求值，或者按需调用，延迟执行）。及早求值会强迫我们表示出所有无穷数据，而这显然是不可能的。</p>
<p>很多语言都默认是惰性的，有些也提供了惰性数据结构以表达无穷集合，并在需要时对自己进行精确计算。</p>
<p>很明显一行代码 <em>result = compute()</em> 所表达的是将<em> compute()</em> 的返回结果赋值给 result。但是 result 的值究竟是多少只有其被用到的时候才有意义。</p>
<p>可见策略的选择会在很大程度上提高性能，特别是当用在链式处理或者数组处理的时候。这些都是函数式程序员所喜爱的编程技术。</p>
<p>这就开创可很多可能性，包括并发执行，并行技术以及合成。</p>
<p>但是，有一个问题，JavaScrip 并不对自身进行惰性求值。话虽如此，Javascript 里的函数库可以有效地模拟惰性求值。</p>
<h3>闭包的全部好处</h3>
<p>所有的函数式语言都有闭包，然而这个语言特性经常被讨论得很神秘。闭包是一个函数，这个函数有着对内部引用的所有变量的隐式绑定。换句话说，该函数对它引用的变量封闭了一个上下文。JavaScript 中的闭包是能够访问父级作用域的函数，即使父级函数已经调用完毕。</p>
<pre>
   function multiplier(factor) {
      return function(number) {
          return number * factor;
      };
   }
  var twiceOf = multiplier(2);
    console.log(twiceOf(6));
//=&gt; 12</pre>
<h3>声明式优于命令式编程</h3>
<p>函数式编程是声明式的，就像数学运算，属性和关系是定义好的。运行时知道怎么计算最终结果。阶乘函数的定义提供了一个例子：</p>
<p><em>factorial(n)       = 1 if n = 1 </em></p>
<p><em>                            n * factorial(n-1) if n &gt; 1 </em></p>
<p>该定义将 factorial(n) 的值关联到 factorial(n-1)，是递归定义。特殊情况下的 factorial(1) 终止了递归。</p>
<pre>
var imperativeFactorial = function(n) {
    if(n == 1) {
        return 1
    } else {
        product = 1;
        for(i = 1; i &lt;= n; i++) {
              product *= i;
        }
        return product;
     }
}
var declarativeFactorial = function(n) {
       if(n == 1) {
             return 1
       } else {
             return n * factorial(n - 1);
      }
  }</pre>
<p>从它实现阶乘计算来看，声明式的阶乘可能看起来像“命令式”的，但它的结构更像声明式的。</p>
<p>命令式阶乘使用可变值、循环计数器和结果来累加计算后的结果。这个方法显式地实现了特定的算法。不像声明式版本，这种方法有许多可变步骤，导致它更难理解，也更难避免 bug 。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTAwMjEzMzcxOTkuanBn.jpg"></p>
<h3>函数式JavaScript库</h3>
<p>有很多函数式库：underscore.js， lodash，Fantasy Land, Functional.js, Bilby.js, fn.js, Wu.js, Lazy.js, Bacon.js, sloth.js, stream.js, Sugar, Folktale, RxJs 等等。</p>
<h3>函数式程序员工具包</h3>
<p><em>map()</em>, <em>filter()</em>, 和 <em>reduce()函数</em> 构成了函数式程序员工具包的核心。 纯高阶函数成了函数式方法的主力。事实上，它们是纯函数和高阶函数应该仿效的典型。它们用一个函数作为输入，返回没有副作用的输出。</p>
<p>这些 JavaScript 函数对每一个函数式程序来说都是至关重要的。他们可以去除循环和语句，使得代码更加整洁。这些都是实现 ECMAScript5.1 的浏览器的标准，他们只处理数组。每次调用都会创建创建并返回一个新的数组。已存在的数组不会被修改。但是稍等，事情很不止于此。。。他们还将函数作为输入参数，通常是作为回调的匿名函数。他们会遍历将整个数组并且将该回调函数应用与每一项！</p>
<p><em>myArray = [1,2,3,4]; </em></p>
<p><em>newArray = myArray.map(function(x) {return x*2}); </em></p>
<p><em>console.log(myArray); // Output: [1,2,3,4] </em></p>
<p><em>console.log(newArray); // Output: [2,4,6,8] </em></p>
<p>除了这三个函数，还有很多函数可以扎入到几乎每一个函数式应用里：</p>
<p><em>forEach(),concat(), reverse(), sort(), every() 以及some()</em>.</p>
<h3><strong>JavaScript的</strong><strong>聚</strong><strong>范式</strong></h3>
<p>JavaScript当然不是严格意义上的函数式编程语言，这也促使了对其他范式的使用：</p>
<ul>
<li>命令式编程：基于详细操作描述式的编程</li>
<li>基于原型的面向对象式编程：基于原型对象及其实例的编程</li>
<li>元程序编程：操纵JavsScript执行模型的编程方式。对元程序编程的一个很好的定义描述为“编程发生在您书写代码做某事的时候，而元程序编程则发生在您书写代码导致某事的解释方式发生变化的时候。</li>
</ul>
<p>原文地址：https://dzone.com/articles/functional-programming-using-javascript-part-1</p>
<p>翻译：simei231, 祝青, 李中凯</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索函数式编程<br />
                                    javascript函数式编程、javascript 函数编程、函数式编程高级技巧、javascript编程、javascript编程培训，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 03:52:37</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0%e5%bc%8f%e7%bc%96%e7%a8%8b/" title="函数式编程">函数式编程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用 JavaScript 进行函数式编程 (一) 翻译_javascript技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYEvJb.html" rel="bookmark">Javascript函数式编程简单介绍&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				几十年来,函数式编程一直是计算机科学狂热者的至爱,由于数学的纯洁性和谜一般的本质, 它被埋藏在计算机实验室,只有数据学家和有希望获得博士学位的人士使用.但是现在,它正经历一场复兴, 这要感谢一些现代语言比如Python,Julia,Ruby,Clojure以及--但不是最后一个--Javascript. 你是说Javascript?这个WEB脚本语言?没错! Javascript已经被证明是一项长期以来都没有消失的重要的技术.这主要是由于它扩展的一些框架和库而使其具有重生的能力, 比如backb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL52eaz.html" rel="bookmark">javascript函数式编程实例分析&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了javascript函数式编程.分享给大家供大家参考.具体分析如下: js像其他动态语言一样是可以写高阶函数的,所谓高阶函数是可以操作函数的函数.因为在js中函数是一个彻彻底底的对象,属于第一类公民,这提供了函数式编程的先决条件. 下面给出一个例子代码,出自一本js教程,功能是计算数组元素的平均值和标准差,先列出非函数式编程的一种写法: var data = [1,1,3,5,5]; var total = 0; for(var i = 0;i &lt; data.length;i++)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj89q6p.html" rel="bookmark">JavaScript 函数式编程的原理&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1,JavaScript中函数.方法的调用 在JavaScript中,有两种调用函数的方式.一般的方式是把参数放在括号中,另一种方式是同时把函数和参数都放在括号中.如: 复制代码 代码如下: function test(x) { alert(x); } test(&quot;hello&quot;); (test)(&quot;hello&quot;); //等同于下面的代码 (function test(x) { alert(x); })(&quot;hello&quot;); //也等同于下面的代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0yZ0p.html" rel="bookmark">探究JavaScript函数式编程的乐趣&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编程范式 编程范式是一个由思考问题以及实现问题愿景的工具组成的框架.很多现代语言都是聚范式(或者说多重范式): 他们支持很多不同的编程范式,比如面向对象,元程序设计,泛函,面向过程,等等. 函数式编程范式 函数式编程就像一辆氢燃料驱动的汽车--先进的未来派,但是还没有被广泛推广.与命令式编程相反,他由一系列语句组成,这些语句用于更新执行时的全局状态.函数式编程将计算转化作表达式求值.这些表达式全由纯数学函数组成,这些数学函数都是一流的(可以被当做一般值来运用和处理),并且没有副作用. 函数式编程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvJWP8M.html" rel="bookmark">《JavaScript函数式编程》读后感&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文章记录本人在学习 函数式 中理解到的一些东西,加深记忆和并且整理记录下来,方便之后的复习. 在近期看到了&lt;JavaScript函数式编程&gt;这本书预售的时候就定了下来.主要目的是个人目前还是不理解什么是函数式编程.在自己学习的过程中一直听到身边的人说面向过程编程和面向对象编程,而函数式就非常少.为了自己不要落后于其他同学的脚步,故想以写笔记的方式去分享和记录自己阅读中所汲取的知识. js 和函数式编程 书中用了一句简单的话来回答了什么是函数式编程: 函数式编程通过使用函数来将值转换为抽象单元			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Q6Lqp.html" rel="bookmark">跟我学习javascript解决异步编程异常方案&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.JavaScript异步编程的两个核心难点 异步I/O.事件驱动使得单线程的JavaScript得以在不阻塞UI的情况下执行网络.文件访问功能,且使之在后端实现了较高的性能.然而异步风格也引来了一些麻烦,其中比较核心的问题是: 1.函数嵌套过深 JavaScript的异步调用基于回调函数,当多个异步事务多级依赖时,回调函数会形成多级的嵌套,代码变成 金字塔型结构.这不仅使得代码变难看难懂,更使得调试.重构的过程充满风险. 2.异常处理 回调嵌套不仅仅是使代码变得杂乱,也使得错误处理更复杂.这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZdyY4M.html" rel="bookmark">比较不错的函数式JavaScript编程指南教程&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你是否知道JavaScript其实也是一个函数式编程语言呢?本指南将教你如何利用JavaScript的函数式特性. 要求:你应当已经对JavaScript和DOM有了一个基本的了解. 写这篇指南的目的是因为关于JavaScript编程的资料太多了但是极少的资料提到了JavaScript的函数式特性.在本指南中,我只会讲解这些基本知识而不会深入其它的函数式语言或这是Lambda算子. 你可以点击所有的例子然后你所看到的代码就会被执行,这样就可以令指南变得具有交互性.你也可以使用这个沙箱来尝试. 第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQDgmz.html" rel="bookmark">&lbrack;译&rsqb; JavaScript 的函数式编程是一种反模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是[译] JavaScript 的函数式编程是一种反模式, 原文地址:Functional programming in JavaScript is an antipattern 原文作者:Alex Dixon 译文出自:掘金翻译计划 本文永久链接:github.com/xitu/gold-m- 译者:sunui 校对者:LeviDing.xekri 其实 Clojure 更简单些 写了几个月 Clojure 之后我再次开始写 JavaScript.就在我试着写一些很普通的东西的时候,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5o3yRb.html" rel="bookmark">为什么用 JavaScript 学习函数式编程？（软件编写）（第二部分）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是为什么用 JavaScript 学习函数式编程?(软件编写)(第二部分), 烟雾的方块艺术 -MattysFlicks -(CC BY 2.0) 注意:这是从基础学习函数式编程和使用 JavaScript ES6+ 撰写软件的第二部分.保持关注,接下来还有很多!第一篇 | 第三篇 &gt; 忘掉你认为知道的关于 JavaScript 的一切,用初学者的眼光去看待它.为了帮助你做到这一点,我们将会从头复习一下 JavaScript 的基础,就像你与其尚未谋面一样.如果你是初学者,那你就很幸运了			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9XVKb.html" rel="bookmark" class="title">要想百度收录内页必须满足三个前提条件</a>
					<div>
						最近发现一些新手站长总是在抱怨内页为什么不被百度收录,我觉得这些新手老是抱怨这个抱怨那个,都不想一下自己是否没有处理好,都没有总结自己的经验,老是抱怨;还有一些新手老是抱怨说百度收录了内页过一段时间就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mvlr5z.html" rel="bookmark" class="title">JavaScript特效的实现</a>
					<div>
						网页制作Webjx文章简介:1.不同时间段显示不同问候语 〈script Language=Javascript〉 〈!-- var text=; day = new Date( ); time =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b33ogb.html" rel="bookmark" class="title">seo是一场勇敢者的游戏</a>
					<div>
						  搜索引擎优化的进退两难 什么是合理的搜索引擎优化,什么是过度的搜索引擎优化?没有没一条清晰的红线来明断左右?答案是否定的. 搞seo的seoer和站长们,每个人都在如履薄冰如临深渊地试探百度谷歌这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Pxq8M.html" rel="bookmark" class="title">WPF 字体、颜色等属性的序列化和反序列化</a>
					<div>
						WPF自带的一些属性比如System.Windows.Media.Brush.System.Windows.Media.FontFamily.System.Windows.FontWeight等不具有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK70B7b.html" rel="bookmark" class="title">Live Messenger集成的实用搜索功能</a>
					<div>
						最近在MSN聊天窗口里面多了一个实用的搜索功能,不知道大家有没有用过.感觉用起来还挺方便的,所以秀出来和大家分享一下. 这个东东是我在摆弄聊天窗口里面的&quot;活动&quot;功能时发现的,不太好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxQv2b.html" rel="bookmark" class="title">用iSee看网易相册及百度空间相册</a>
					<div>
						有了iSee图片专家,你可以无需打开浏览器,即可查看你的网上相册.支持的相册包括: - iSee网上相册 - 163网上相册 - 百度空间相册 一.功能概述: 1. 读取iSee和163网上相册,查看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywrdJz.html" rel="bookmark" class="title">linux中利用Shell脚本自动提交网站404死链到搜索引擎</a>
					<div>
						  Shell脚本 说做就做,简单的写了个 Shell 脚本就搞定了! 脚本名称:网站死链生成脚本 脚本功能:每天定时分析网站前一天的 nginx 日志, 然后提取状态码为404并且UA为百度蜘蛛的抓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywZ1dz.html" rel="bookmark" class="title">什么是音速启动</a>
					<div>
						音速启动是一个模仿qq界面的一个软件.它结合了桌面工具的特点,可以应用于软件及文件夹.网站等快捷操作.比如qq账号登陆,可以注解在上面设置一下,在下次即可直接登录了.可以不用输入账号和密码了.提高效率 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLjqmb.html" rel="bookmark" class="title">新浪微博如何发布定向微博&quest;</a>
					<div>
						  在您将关注的对象设置分组之后,您可以定向发布,将微博发送到你分组的组员中;如您选择将微博发布到&quot;家人&quot;的分组,那么只有在&quot;家人&quot;这个分组中且与您相互关注的微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badnvNz.html" rel="bookmark" class="title">91助手无法登录Apple ID怎么办</a>
					<div>
						  91助手无法登录Apple ID怎么办?现在,不少人都在使用91助手这个软件.而在使用的时候,不少用户都发现,91助手无法登录Apple ID.那么,91助手无法登录Apple ID怎么办?今天, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZnlwz.html" rel="bookmark" class="title">WinXP系统如何在右下角显示星期几</a>
					<div>
						  1.点击&quot;开始&quot;菜单→&quot;控制面板&quot;,找到并双击&quot;区域与语言选项&quot;图标 2.然后,在弹出的设置窗口中点击&quot;区域选项&quot;标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z720OXp.html" rel="bookmark" class="title">电脑打字很卡怎么办</a>
					<div>
						  故障现象: 打字感觉卡,输入了几个字母后输入法才一个一个的显示. 解决方案: 一.设置问题 1.在&quot;控制面板&quot;里面选区域与语言选项--语言--详细设置--设置,在&quot;添 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWw8Vp.html" rel="bookmark" class="title">Json实现异步请求提交评论无需跳转其他页面&lowbar;jquery</a>
					<div>
						主要将代码粘贴,通过阅读代码理解其中的相关逻辑. html代码: &lt;form id=&quot;form1&quot; runat=&quot;server&quot;&gt; &lt;p&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPlGlp.html" rel="bookmark" class="title">在Spring Boot项目中使用Spock框架</a>
					<div>
						Spock框架是基于Groovy语言的测试框架,Groovy与Java具备良好的互操作性,因此可以在Spring Boot项目中使用该框架写优雅.高效以及DSL化的测试用例.Spock通过@RunWi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrWJ0M.html" rel="bookmark" class="title">C&plus;&plus;流实现内幕---由boost&colon;&colon;lexical&lowbar;cast引发的一个问题</a>
					<div>
						中午同事碰见一个关于使用boost::lexical_cast产生异常的问题,关键代码如下 string str(8,'/0'); strncpy(&amp;str.at(0),&quot;12345 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZE4Dap.html" rel="bookmark" class="title">学生创建反CNN网站 做人不能太CNN成流行语</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 反CNN网站首页 华盛顿邮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrW4xOp.html" rel="bookmark" class="title">js 翻页-关于图片翻页的js代码</a>
					<div>
						问题描述 关于图片翻页的js代码 如下图所示的样式,js代码如何写 解决方案 爬这个网站的js效果下来不就好了,很简单,不会爬你发链接出来 解决方案二: 画了一张图的,可惜公司有限制上传不上去..艹  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWq3Bp.html" rel="bookmark" class="title">ios webview加载本地文件时崩溃</a>
					<div>
						问题描述 ios webview加载本地文件时崩溃 加载本地一个docx格式的文件,程序崩溃,exc_bad_access 完全没有异常信息 解决方案 http://www.lxway.com/884 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7J9Wz.html" rel="bookmark" class="title">大家有遇到过AutoScanning指标报警了没并且也没有触发CloudWatch策略和SNS服务吗&quest;</a>
					<div>
						问题描述 大家有遇到过AutoScanning指标报警了没并且也没有触发CloudWatch策略和SNS服务吗?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ4Z6z.html" rel="bookmark" class="title">你知道产品经理管理职位的级别有哪些吗？</a>
					<div>
						似乎饿着肚子睡觉反而是睡得更香. 但是在我正睡得稀里哗啦的时候,手机的短信铃声就响了,十分烦人,因为睡觉不关手机本不是我的习惯,但是以前的公司却要求我们这么做,而且还美其名曰是&quot;这样可以随时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZqdyM.html" rel="bookmark" class="title">VR&sol;AR未来将颠覆哪些产业？看&OpenCurlyDoubleQuote;老司机&rdquo;如何作答</a>
					<div>
						很抱歉,让您久等了! 2016年12月14日至15日,在北京诺金酒店,备受行业瞩目的Vision VR/AR Summit将首次来到亚洲.本次峰会将以开发者为中心,并诚邀包括Microsoft.Son ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBXP8b.html" rel="bookmark" class="title">java&period;io 中不使用close&lpar;&rpar;方法资源为何cg无法回收？</a>
					<div>
						问题描述 java.io 中不使用close()方法资源为何cg无法回收? 如题,new FileInputStream()新建的文件流都必须要调用close()方法关闭,close方法的介绍是关闭和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmAn9b.html" rel="bookmark" class="title">优维科技将参加微软加速器&CenterDot;上海一期Demo Day</a>
					<div>
						亲爱的小伙伴们! 微软加速器·上海一期创新创业展示日Demo Day 6月22日即将盛大启航!活动报名正在火热进行中!届时,政府高层.合作伙伴高层.知名风投机构.众多优秀创业企业和近80家媒体等近50 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94Lodb.html" rel="bookmark" class="title">据说是与100个码农相亲之后总结的相亲指南</a>
					<div>
						简评:程序员们呀,都能把计算机搞得七颠八倒的,和女人打起交道竟这么笨蛋.这篇文章据说是相亲了100个程序员之后总结而成的程序员相亲指南,九条经验之谈,每一条都很走心,从不要拒绝相亲.聊天话题.地点选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYryLp.html" rel="bookmark" class="title">妙用脚本和批处理清除电脑中的痕迹&lowbar;DOS&sol;BAT</a>
					<div>
						我们知道,使用Windows操作系统在你打开文件.输入各种密码或用QQ与朋友聊天,都可能引发个人机密泄漏,都会在机器上留下踪迹.为安全起见,如果是在公用电脑上,你应该在离开时抹去这些操作后留下的痕迹, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKgXOz.html" rel="bookmark" class="title">jar-项目上有个红色感叹号</a>
					<div>
						问题描述 项目上有个红色感叹号 导入的maven项目有个红色感叹号,找不出哪里出错了 构建的时候会出现两个错误 jar也看不出是哪里错误 谁知道是哪里问题,求大神解答 解决方案 右键单击你的web工程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rywKp.html" rel="bookmark" class="title">输入输出文件流</a>
					<div>
						首先建立一个单文档视图,记得VIEW的父类要选CFORMVIEW.这样的话可以在VIEW的界面中出现一个类似于对话框的东西,然后在上面放上两个对话框和两个编辑框.对两个编辑框创建两个控件变量.针对两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Q2y4M.html" rel="bookmark" class="title">马云：如果想成为伟大的公司，必须要解决社会问题</a>
					<div>
						[编者按]近日,http://www.aliyun.com/zixun/aggregation/7554.html&quot;&gt;阿里巴巴集团董事局主席马云到韩国首尔大学发表演讲.在演讲中,马云指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0R6jp.html" rel="bookmark" class="title">看PDF、Flash中毒解决方法&lowbar;网络冲浪</a>
					<div>
						我们电脑以及网上的文件中,哪些类型文件是安全的?除了很早就被病毒盯上了的可执行文件.邮件.即时通讯工具之外,一些平时经常使用的文件类型如PDF.Flash等也难逃病毒的魔掌.大家平时可得加以注意,并希 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV78YDb.html" rel="bookmark" class="title">renren是否有风水问题，谁买谁倒下！</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 以下为引用的内容: 今天, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
